import {IGuard} from "@core/Defined";
import {bizTokenGuard} from "@core-guards/rest/bizTokenGuard";

/**
 * 例子：
 *
 export const apiGuards: Array<IGuard> = [
    {
        path: ['/api/device/online'],
        guards: [appKeyGuard, uuidStatusGuard]
    },
 ]
 */

export const apiGuards: Array<IGuard> = [
    {
        path: ['/api/mp/login', '/api/client/login', '/api/client/get_vcode'],
        guards: []
    },
    {
        path: [
            '/api/mp/post_userinfo',
            '/api/mp/get_self_info',
            '/api/mp/set_self_info',
            '/api/client/logout',
            '/api/client/get_permissions',
            '/api/client/get_self_info',
            '/api/client/set_self_info',
            '/api/info.*.*'],
        guards: [bizTokenGuard]
    },
    {
        path: ['/api/*'],
        guards: [bizTokenGuard]
    }
];
