import {Resp} from "@util/Resp";
import {extend} from "@util/JsonToolkit";
import {Redis} from "@util/Redis";
import {ICachedData} from "@core/Defined";

export function bizTokenGuard(json: any, cached_data: ICachedData): Promise<void> {
    return new Promise<void>(async (resolve, reject) => {
        let token = json.token || json.access_token;
        if (!token) {
            return reject(Resp.gen_err(Resp.Unauthorized));
        }
        let redis = Redis.get_instance('client-token');
        try {
            let result = await redis.hgetall(token, redis.expires);
            if (!result) return reject(Resp.gen_err(Resp.Unauthorized));
            if (result.app_id !== (json.app_id || json.app_key))// || result.app_pass !== json.app_pass)
                return reject(Resp.gen_err(Resp.Unauthorized));
            if (!json.__cachedData) json.__cachedData = {};
            extend(json.__cachedData, result, true);
            return resolve();
        } catch (e: any) {
            return reject(Resp.gen_err(Resp.RedisServerError, e.message));
        }

    });
}
