import {Model, DataTypes} from "sequelize";

export class AcsRole extends Model {
    declare id: string;
    declare name: string;
    declare tag: string;

    static table_name = 'tb_acs_role';
    static attributes = {
        id: {
            type: DataTypes.STRING,
            primaryKey: true,
            comment: '角色id'
        },
        name: {
            type: DataTypes.STRING,
            comment: '角色名称'
        },
        tag: {
            type: DataTypes.STRING,
            comment: '标签',
            defaultValue: 'sys'
        },

    }

    static init_sqls = [
        `insert into tb_acs_role (id, name, tag) values
            ('admin', '系统管理员', 'sys')
            ON CONFLICT DO NOTHING `,
        `insert into tb_acs_role (id, name, tag) values
            ('cto', '技术总监', 'sys')
            ON CONFLICT DO NOTHING `,
        `insert into tb_acs_role (id, name, tag) values
            ('prj_leader', '项目组长', 'prj')
            ON CONFLICT DO NOTHING `,
        `insert into tb_acs_role (id, name, tag) values
            ('prj_member', '项目成员', 'prj')
            ON CONFLICT DO NOTHING `
    ]
}
