import {Model} from "sequelize";
import {AcsUserInfo} from "@core-models/AcsUserInfo";
import { Sequelize, DataTypes }  from 'sequelize';
import {AcsRole} from "@core-models/AcsRole";

/**
 * 账号角色对应表
 */

export class AcsUserRole extends Model {
    public user_id: string;
    public role_id: number;

    static table_name = 'tb_acs_user_role';

    static attributes = {
        user_id: {
            type: DataTypes.STRING,
            primaryKey: true,
            comment: '用户账号',
            references: {
                model: AcsUserInfo,
                key: 'id'
            }
        },
        role_id: {
            type: DataTypes.STRING,
            primaryKey: true,
            comment: '角色',
            references: {
                model: AcsRole,
                key: 'id'
            }
        },

    }

    static indexes = [
        {fields: ['user_id', 'role_id']}
    ]

    static associate(sequelize: Sequelize) {
        try {
            // AcsUserInfo.belongsToMany(AcsRole, { through: AcsUserRole, foreignKey: 'id', otherKey: 'role_id' });
            // AcsRole.belongsToMany(AcsUserInfo, { through: AcsUserRole, foreignKey: 'id', otherKey: 'user_id' });
            // AcsUserRole.belongsTo(AcsUserInfo, {foreignKey: 'user_id', targetKey: 'id', as: 'RoleUserInfo'});
            // AcsUserRole.belongsTo(AcsRole, {foreignKey: 'role_id', targetKey: 'id'});
            // AcsUserInfo.hasMany(AcsUserRole, {foreignKey: 'user_id', sourceKey: 'id'});
            // AcsRole.hasMany(AcsUserRole, {foreignKey: 'role_id', sourceKey: 'id'});
        } catch (e) {
            console.log(e);
        }
    }

    static init_sqls = [
        // `insert into tb_acs_user_role (user_id, role_id) values
        //     ('administrator', 'admin')
        //     ON CONFLICT DO NOTHING `,
        `insert into tb_acs_user_role (user_id, role_id) values
            ('admin', 'admin')
            ON CONFLICT DO NOTHING `,
        // `insert into tb_acs_user_role (user_id, role_id) values
        //     ('test', 'admin')
        //     ON CONFLICT DO NOTHING `,
        `insert into tb_acs_user_role (user_id, role_id) values
            ('master', 'admin')
            ON CONFLICT DO NOTHING `,
    ]
}
