import {Model} from "sequelize";
import { Sequelize, DataTypes }  from 'sequelize';

/**
 * 客户行业分类表
 */

export class BizCustomerIndustry extends Model {
    declare id: string;
    declare name: number;

    static table_name = 'tb_biz_customer_industry';

    static attributes = {
        id: {
            type: DataTypes.STRING(16),
            primaryKey: true,
            comment: '行业编号',
        },
        name: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '行业名称',
        }

    }

    static indexes = [

    ]

    static associate(sequelize: Sequelize) {

    }

    static init_sqls = [
        `insert into ${BizCustomerIndustry.table_name} (id, name) values ('other', '其它') ON CONFLICT DO NOTHING; `,
    ]
}
