import {Model} from "sequelize";
import { Sequelize, DataTypes }  from 'sequelize';

/**
 * 客户级别表
 */

export class BizCustomerLevel extends Model {
    declare id: string;
    declare name: number;
    declare order_index: number;

    static table_name = 'tb_biz_customer_level';

    static attributes = {
        id: {
            type: DataTypes.STRING(16),
            primaryKey: true,
            comment: '客户级别编号',
        },
        name: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '客户级别名称',
        },
        order_index: {
            type: DataTypes.INTEGER,
            allowNull: false,
            comment: '排序'
        }

    }

    static indexes = [

    ]

    static associate(sequelize: Sequelize) {

    }

    static init_sqls = [
        `insert into ${BizCustomerLevel.table_name} (id, name, order_index) values ('VIP', 'VIP客户', 1) ON CONFLICT DO NOTHING; `,
        `insert into ${BizCustomerLevel.table_name} (id, name, order_index) values ('A', 'A类客户', 2) ON CONFLICT DO NOTHING; `,
        `insert into ${BizCustomerLevel.table_name} (id, name, order_index) values ('B', 'B类客户', 3) ON CONFLICT DO NOTHING; `,
        `insert into ${BizCustomerLevel.table_name} (id, name, order_index) values ('C', 'C类客户', 4) ON CONFLICT DO NOTHING; `,
    ]
}
