import {Model} from "sequelize";
import { Sequelize, DataTypes }  from 'sequelize';

const form_prj_approve = `
{
  "type": "object",
  "title": "条件",
  "properties": {
    "pass": {
      "description": "是否通过",
      "type": "boolean"
    },
    "opinion": {
      "type": "string",
      "description": "审核意见",
      "minLength": 10,
      "ui:options": {
        "type": "textarea"
      }
    }
  },
  "ui:order": [
    "pass",
    "opinion"
  ],
  "required": [
    "pass"
  ]
}
`;

/**
 * 流程表单表
 */

export class BpmnForm extends Model {
    declare id: string;
    declare title: string;
    declare form: any;

    static table_name = 'tb_bpmn_form';

    static attributes = {
        id: {
            type: DataTypes.STRING,
            primaryKey: true,
            comment: '表单id',
        },
        title: {
            type: DataTypes.STRING,
            comment: '表单标题'
        },
        schema: {
            type: DataTypes.JSONB,
            comment: '表单定义'
        }
    }

    static indexes = []

    static associate(sequelize: Sequelize) {}

    static init_sqls = [
        `insert into ${BpmnForm.table_name} (id, title, schema) values
            ('prj_approve', '立项审核', '${form_prj_approve}')
            ON CONFLICT DO NOTHING `,

    ]
}
