import {Model} from "sequelize";
import { Sequelize, DataTypes }  from 'sequelize';
import {AcsUserInfo} from "@core-models/AcsUserInfo";

/**
 * 流程模型表
 */

export class BpmnModel extends Model {
    declare id: string;
    declare name: string;
    declare created_at: string;
    declare creator_id: string;
    declare content: string;

    static table_name = 'tb_bpmn_model';

    static attributes = {
        id: {
            type: DataTypes.STRING(16),
            primaryKey: true,
            comment: '流程模型id',
        },
        name: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '模型名称'
        },
        created_at: {
            type: DataTypes.DATE,
            allowNull: false,
            comment: '创建时间'
        },
        updated_at: {
            type: DataTypes.DATE,
            allowNull: true,
            comment: '更新时间'
        },
        creator_id: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '创建人账号',
            references: {
                model: AcsUserInfo,
                key: 'id'
            }
        },
        content: {
            type: DataTypes.TEXT,
            allowNul: false,
            comment: '流程模型'
        }
    }

    static indexes = [

    ]

    static associate(sequelize: Sequelize) {

    }

    static init_sqls = [
        //` insert into ${BpmnModel.table_name} (id, name, created_at, creator_id, content) values ('new', '项目立项', new Date(), 'admin', '') ON CONFLICT DO NOTHING; `,
    ]
}
