import {Model} from "sequelize";
import { Sequelize, DataTypes }  from 'sequelize';
import {AcsUserInfo} from "@core-models/AcsUserInfo";
import {AcsRole} from "@core-models/AcsRole";
import {PrjInfo} from "@core-models/PrjInfo";
import {PrjFlow} from "@core-models/PrjFlow";

/**
 * 流程节点
 */

export class PrjFlowNodes extends Model {
    // declare id: string;

    static table_name = 'tb_prj_flow_nodes';

    static attributes = {
        id: {
            type: DataTypes.STRING(16),
            primaryKey: true,
            comment: '节点编号'
        },
        name: {
            type: DataTypes.STRING,
            comment: '节点名称'
        },
        flow_id: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '流程id',
            references: {
                model: PrjFlow,
                key: 'id'
            }
        },
        type_id: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '节点类型：new=起草，copy=抄送，check=审批，done=完成'
        }

    }

    static indexes = [
        // {fields: ['created_at']},
    ]

    static associate(sequelize: Sequelize) {
        try {
        } catch (e) {
            console.log(e);
        }
    }

    static init_sqls = [
    ]
}
