/// 项目日志数据模型
import {DataTypes, Model, Sequelize} from "sequelize";

export class PrjLogs extends Model {
    declare id: string;
    declare ts: string;
    declare creator_id: string;
    declare creator_name: string;
    declare prj_id: string;
    declare task_id: string;
    declare content: string;


    static table_name = 'tb_prj_logs';

    static attributes = {
        id: {
            type: DataTypes.STRING(16),
            primaryKey: true,
            comment: '流水号',
        },
        ts: {
            type: DataTypes.DATE,
            allowNull: false,
            comment: '时间',
            default: DataTypes.NOW
        },
        creator_id: {
            type: DataTypes.STRING,
            allowNull: true,
            comment: '创建人',
        },
        creator_name: {
            type: DataTypes.STRING,
            allowNull: true,
            comment: '创建人姓名',
        },
        prj_id: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '项目ID'
        },
        task_id: {
            type: DataTypes.STRING,
            allowNull: true,
            comment: '任务ID'
        },
        content: {
            type: DataTypes.TEXT,
            allowNull: false,
            comment: '内容',
        }
    }

    static indexes = [
        {fields: ['ts']},
        {fields: ['prj_id']},
        {fields: ['task_id']}
    ]

    static associate(sequelize: Sequelize) {
    }

    static init_sqls = [
    ]
}
