import {Model} from "sequelize";
import { Sequelize, DataTypes }  from 'sequelize';
import {AcsUserInfo} from "@core-models/AcsUserInfo";
import {AcsRole} from "@core-models/AcsRole";
import {PrjInfo} from "@core-models/PrjInfo";

/**
 * 工单表
 */

export class PrjWorkTicket extends Model {
    // declare id: string;

    static table_name = 'tb_prj_work_ticket';

    static attributes = {
        id: {
            type: DataTypes.STRING(16),
            primaryKey: true,
            comment: '工单号'
        },
        type_id: {
            type: DataTypes.STRING,
            allowNull: false,
            comment: '工单类型，1=增加项目成员，2=删除项目成员，10=立项，',
        },
        flow_id: {
            type: DataTypes.STRING(16),
            allowNull: true,
            comment: '审批流程id'
        },
        flow_node_id: {
            type: DataTypes.STRING(16),
            allowNull: true,
            comment: '流程节点id'
        },
        status: {
            type: DataTypes.INTEGER,
            allowNull: false,
            comment: '工单状态，0=新到达，1=已撤回，2=已驳回，10=已完成'
        },
        // flow_status: {
        //     type: DataTypes.STRING,
        //     allowNull: true,
        //     comment: '审批流程状态，new=新申请，checking=审核中，canceled=已撤回，rejected=已驳回，passed=审核通过'
        // },
        memo: {
            type: DataTypes.TEXT,
            allowNull: true,
            comment: '说明'
        },
        created_at: {
            type: DataTypes.DATE,
            allowNull: false,
            comment: '创建时间',
            default: DataTypes.NOW
        },
        updated_at: {
            type: DataTypes.DATE,
            allowNull: true,
            comment: '最近修改时间'
        }

    }

    static indexes = [
        // {fields: ['created_at']},
        // {fields: ['member_id']},
        // {fields: ['role_id']},
        // {fields: ['member_id', 'role_id']},
    ]

    static associate(sequelize: Sequelize) {
        try {
        } catch (e) {
            console.log(e);
        }
    }

    static init_sqls = [
    ]
}
