import {Model} from "sequelize";
import { Sequelize, DataTypes }  from 'sequelize';

/**
 * 项目累计延误率报表（每日23:50统计一次），针对已完成和未完成的项目
 */

export class ReportTaskDelayRate extends Model {
    declare ts: string;
    declare total_count: number;
    declare delayed_count: number;
    declare delay_rate: number;

    static table_name = 'tb_report_task_delay_rate';

    static attributes = {
        ts: {
            type: DataTypes.DATEONLY,
            allowNull: false,
            comment: '日期',
            primaryKey: true,
        },
        total_count: {
            type: DataTypes.INTEGER,
            comment: '项目数量',
        },
        delayed_count: {
            type: DataTypes.INTEGER,
            comment: '延期数量',
        },
        delay_rate: {
            type: DataTypes.FLOAT,
            comment: '延期率',
        }
    }

    static indexes = [
        {fields: ['ts']},
    ]

    static associate(sequelize: Sequelize) {
        try {
        } catch (e) {
            console.log(e);
        }
    }

    static init_sqls = [
    ]
}
