//生成雪花id
import FlakeId from "flake-idgen";
const int_format = require('biguint-format');

export class IdGen {
    static flake_id: FlakeId;

    static init(id: number | string) {
        if (typeof id === 'string') {
            id = uuid_to_number(id);
        }
        IdGen.flake_id = new FlakeId({id: id})
    }

    static id(): string {
        return int_format(IdGen.flake_id.next(), 'hex').padStart(16, '0');
    }

}

function uuid_to_number(uuid: string): number {
    const hex: string = uuid.replace(/-/g, '');
    let sum = 0;
    for (let i = 0; i < hex.length; i += 15) {
        const chunk = hex.slice(i, i + 15);
        const num = parseInt(chunk, 16);
        sum = (sum * 2 ** 60) + num;
    }

    return sum;
}
