const stringify = require('json-stringify-safe');// 不会死循环

export function extend(des: any, src: any, override?: boolean) {
    if (src instanceof Array) {
        for (let i = 0, len = src.length; i < len; i++)
            extend(des, src[i], override);
    }
    for (let i in src) {
        if (override || !(i in des)) {
            des[i] = src[i];
        }
    }
    return des;
}

export function clone(json: any): any {
    return JSON.parse(stringify(json));
}

// 对json字段按ascii码排序
export function obj_key_sort(obj: any) {
    let new_key: any = Object.keys(obj).sort();
    //先用Object内置类的keys方法获取要排序对象的属性名，再利用Array原型上的sort方法对获取的属性名进行排序，new_key是一个数组
    let new_obj: any = {};//创建一个新的对象，用于存放排好序的键值对
    for (let i = 0; i < new_key.length; i++) {//遍历new_key数组
        if (obj[new_key[i]] instanceof Object) {
            new_obj[new_key[i]] = obj_key_sort(obj[new_key[i]]);
        } else new_obj[new_key[i]] = obj[new_key[i]];//向新创建的对象中按照排好的顺序依次增加键值对
    }
    return new_obj;//返回排好序的新对象
}


// Define a function to remove fields from a JSON object if they have default values.
export function remove_default_fields(obj: any, schema: any) {
    for (let key of Object.keys(obj)) {
        const value = obj[key];
        if (typeof value === "object" && !Array.isArray(value) && schema.properties.hasOwnProperty(key)) {
            // Recursively remove default properties from objects that have a matching schema in the parent schema
            //   if (Array.isArray(value)) {
            //     for (let index in value) {
            //       value[index] = removeDefaultProperties(value[index], schema.properties[key].items.properties);
            //     }
            //   } else {
            obj[key] = remove_default_fields(value, schema.properties[key]);
            //   }
        } else if(Array.isArray(value)) {
            for (let index in value) {
                value[index] = remove_default_fields(value[index], schema.properties[key].items);
            }
        } else {
            // Remove the property if its value matches the default value specified in the schema
            if (schema.properties.hasOwnProperty(key) &&
              schema.properties[key].hasOwnProperty("default") &&
              value === schema.properties[key].default) {
                delete obj[key];
            }
        }
    }
    return obj;
}
