import {Resp} from "@util/Resp";
import {ADMINISTRATOR, ICachedData, IRequest} from "@core/Defined";
import {AcsRole} from "@core-models/AcsRole";
import {AcsRoleFunction} from "@core-models/AcsRoleFunction";
import {AcsUserRole} from "@core-models/AcsUserRole";
import {QueryTypes} from "sequelize";


export function roleGuard(json: IRequest, cached_data: ICachedData): Promise<void> {
    return new Promise<void>(async (resolve, reject) => {
        let user = cached_data.user_id;
        let data: any = json.data;
        if (!user) return reject(Resp.gen_err(Resp.Forbidden));
        if (user === ADMINISTRATOR) return resolve();
        let roles = data.roles;
        if (roles === undefined) return reject(Resp.gen_err(Resp.ParamsError, 'should have required property \'roles\''));
        try {
            let sql = ` select id from ${AcsRole.table_name} where id not IN ( 
                        SELECT DISTINCT role_id 
                        FROM ${AcsRoleFunction.tableName} a 
                        WHERE NOT exists 
                        ( 
                            SELECT func_id 
                            FROM ${AcsRoleFunction.tableName},${AcsUserRole.tableName}
                            WHERE 
                            ${AcsRoleFunction.tableName}.role_id = ${AcsUserRole.tableName}.role_id AND 
                            ${AcsUserRole.tableName}.user_id = '${user}' and func_id = a.func_id 
                        )
                    ) `;

            sql = `select id from ${AcsRole.tableName} where id not in ( ` +
              sql +
              ') and (';

            let where_str = '';
            let index = 1;
            for (let i = 0; i < roles.length; i++) {
                if (where_str != '') {
                    where_str += ' or ';
                }
                index++;
                where_str += `id='${roles[i].id}'`;
            }
            sql = sql + where_str;
            sql += ')';
            let result = await AcsRole.sequelize!.query(sql, {type: QueryTypes.SELECT});
            if (result.length > 0) {
                return reject(Resp.gen_err(Resp.Forbidden));
            }
            resolve();
        } catch (e) {
            reject(e);
        }
    });
}
