import {IApiProcessor} from "@core/Defined";
import {AcsRole} from "@core-models/AcsRole";
import DataCURD from "@core/DataCURD";

const v1_0: IApiProcessor = {
    schema: {
        "$schema": "http://json-schema.org/draft-07/schema#",
        "type": "object",
        "title": "添加角色",
        "properties": {
            "ver": {
                "type": "string",
                "title": "版本号，默认1.0",
                "default": "1.0"
            },
            "app_id": {
                "type": "string",
                "title": "平台分配的app id"
            },
            "token": {
                "type": "string",
                "title": "登录后获得的令牌"
            },
            "timestamp": {
                "type": "integer",
                "title": "时间戳"
            },
            "sign": {
                "type": "string",
                "title": "签名"
            },
            "data": {
                "type": "object",
                "title": "业务参数",
                "properties": {
                    "role_id": {
                        "type": "string"
                    },
                    "role_name": {
                        "type": "string"
                    },
                },
                "required": [
                    "role_id",
                    "role_name",
                ]
            }
        },
        "required": [
            "ver", "app_id", "timestamp",
            "data",
        ]
    },
    method: DataCURD.internal_add_row,
    method_params: {
        model: AcsRole,
        fixed_input_data: {
            tag: 'sys'
        },
        input_data_map: {
            role_id: 'id',
            role_name: 'name'
        }
    },
    guards: []
}

module.exports = {
    default: v1_0,
    v1_0: v1_0
}
