import {IApiProcessor} from "@core/Defined";
import {AcsDomain} from "@core-models/AcsDomain";
import DataCURD from "@core/DataCURD";

const v1_0: IApiProcessor = {
    schema: {
        "$schema": "http://json-schema.org/draft-07/schema#",
        "type": "object",
        "properties": {
            "ver": {
                "type": "string",
                "title": "版本号，默认1.0",
                "default": "1.0"
            },
            "app_id": {
                "type": "string",
                "title": "平台分配的app id"
            },
            "token": {
                "type": "string",
                "title": "登录后获得的令牌"
            },
            "timestamp": {
                "type": "integer",
                "title": "时间戳"
            },
            "sign": {
                "type": "string",
                "title": "签名"
            },
            "data": {
                "type": "object",
                "title": "业务参数",
                "properties": {
                    "pid": {
                        "type": "integer",
                        "title": "父域id"
                    },
                }
            }
        },
        "required": [
            "ver", "app_id", "timestamp",
        ]
    },
    method: DataCURD.internal_get_tree,
    method_params:{
        model: AcsDomain
    }
}

module.exports = {
    default: v1_0,
    v1_0: v1_0
}
