module.exports = {
    bail: 0, // 有测试错误后就停止错误
    moduleFileExtensions: ['ts', 'tsx', 'js', 'jsx', 'json', 'node'],
    preset: 'ts-jest',
    transform: {
        "^.+\\.ts?$": "ts-jest"
    },
    testEnvironment: "node",
    rootDir: './',
    "moduleDirectories": [
        "node_modules",
        "src"
    ],
    moduleNameMapper: {
        "^@src/(.*)$": "<rootDir>/src/$1",
        "^@root/(.*)$": "<rootDir>/../$1",
        "^@classes/(.*)$": "<rootDir>/../base-lib/src/classes/$1",
        "^@util/(.*)$": "<rootDir>/../base-lib/src/util/$1",
        "^@core/(.*)$": "<rootDir>/../base-lib/src/core/$1",
        "^@core-guards/(.*)$": "<rootDir>/../base-lib/src/core-guards/$1",
        "^@core-models/(.*)$": "<rootDir>/../base-lib/src/core-models/$1",
    },
    transformIgnorePatterns: ['<rootDir>/node_modules/'],
    "testRegex": "\\.spec\\.ts",
    "verbose": true
};
