import {Router} from "@core/Router";
import {IGuard} from "@core/Defined";

export class MyRouter extends Router {
    private readonly modulesReq: any;

    constructor(routesPath: string, guards: Array<IGuard>) {
        super(routesPath, guards);

        if (process.env.NODE_ENV !== 'development') {
            this.modulesReq = require.context('@src/routes', true, /\.ts$/, 'sync');
            this.modulesReq.keys().forEach((module: any) => {
                this.modulesReq(module);
            });
        }
    }

    protected get_target_module(requirePath: string, requestMethod: string, ver: string) {
        let result;
        try {
            result = this.modulesReq('.' + requirePath + requestMethod + '.ts')[ver];
        } catch (e) {
            console.log(e);
        }

        if (result) return result;
        try {
            if (!result) {
                result = requireDynamically('.' + requirePath + requestMethod)[ver];
            }
        } catch (e) {
            console.log(e);
        }

        return result;
    }
}

function requireDynamically(path: string) {
    path = path.split('\\').join('/'); // Normalize windows slashes
    return eval(`require('${path}');`); // Ensure Webpack does not analyze the require statement
}
