import {IDataModelInfo} from "@core/InitDataModel";
import {AcsUserInfo} from "@core-models/AcsUserInfo";
import {AcsDomain} from "@core-models/AcsDomain";
import {BizCustomer} from "@core-models/BizCustomer";
import {BizCustomerLevel} from "@core-models/BizCustomerLevel";
import {BizCustomerIndustry} from "@core-models/BizCustomerIndustry";
import {BizContractInfo} from "@core-models/BizContractInfo";
import {PrjPhaseDefine} from "@core-models/PrjPhaseDefine";
import {PrjInfo} from "@core-models/PrjInfo";
import {PrjMembers} from "@core-models/PrjMembers";
import {AcsRole} from "@core-models/AcsRole";
import {PrjPlanTask} from "@core-models/PrjPlanTask";
import {PrjTaskOutcome} from "@core-models/PrjTaskOutcome";
import {PrjWeekReport} from "@core-models/PrjWeekReport";
import {PrjFile} from "@core-models/PrjFile";
import {PrjFileCategory} from "@core-models/PrjFileCategory";
import {AcsUserDomain} from "@core-models/AcsUserDomain";
import {AcsUserRole} from "@core-models/AcsUserRole";
import {BpmnModel} from "@core-models/BpmnModel";
import {BpmnCase} from "@core-models/BpmnCase";
import {BpmnWork} from "@core-models/BpmnWork";
import {BpmnForm} from "@core-models/BpmnForm";
import {PrjPlanTaskDraft} from "@core-models/PrjPlanTaskDraft";
import {PrjTaskOutcomeDraft} from "@core-models/PrjTaskOutcomeDraft";
import {PrjLogs} from "@core-models/PrjLogs";
import {ReportPrjStat} from "@core-models/ReportPrjStat";
import {ReportTaskStat} from "@core-models/ReportTaskStat";
import {ReportTaskDelayRate} from "@core-models/ReportTaskDelayRate";

export const Models: Array<IDataModelInfo> = [
    {tag: 'acs', model: AcsDomain, timestamps: false},
    {tag: 'acs', model: AcsUserInfo, timestamps: false},
    {tag: 'acs', model: AcsUserDomain, timestamps: false},
    {tag: 'acs', model: AcsRole, timestamps: false},
    {tag: 'acs', model: AcsUserRole, timestamps: false},
    {tag: 'pmr', model: BizCustomerLevel, timestamps: false},
    {tag: 'pmr', model: BizCustomerIndustry, timestamps: false},
    {tag: 'pmr', model: BizCustomer, timestamps: false},
    {tag: 'pmr', model: BizContractInfo, timestamps: false},
    {tag: 'pmr', model: PrjPhaseDefine, timestamps: false},
    {tag: 'pmr', model: PrjInfo, timestamps: false},
    {tag: 'pmr', model: PrjFileCategory, timestamps: false},
    {tag: 'pmr', model: PrjFile, timestamps: false},
    {tag: 'pmr', model: PrjMembers, timestamps: false},
    {tag: 'pmr', model: PrjPlanTask, timestamps: false},
    {tag: 'pmr', model: PrjPlanTaskDraft, timestamps: false},
    {tag: 'pmr', model: PrjTaskOutcome, timestamps: false},
    {tag: 'pmr', model: PrjTaskOutcomeDraft, timestamps: false},
    {tag: 'pmr', model: PrjWeekReport, timestamps: false},
    {tag: 'pmr', model: BpmnModel, timestamps: false},
    {tag: 'pmr', model: BpmnCase, timestamps: false},
    {tag: 'pmr', model: BpmnWork, timestamps: false},
    {tag: 'pmr', model: BpmnForm, timestamps: false},
    {tag: 'pmr', model: PrjLogs, timestamps: false},
    {tag: 'pmr', model: ReportPrjStat, timestamps: false},
    {tag: 'pmr', model: ReportTaskStat, timestamps: false},
    {tag: 'pmr', model: ReportTaskDelayRate, timestamps: false}
]
