import {IApiProcessor} from "@core/Defined";
import DataCURD from "@core/DataCURD";
import {AcsDomain} from "@core-models/AcsDomain";

const v1_0: IApiProcessor = {
    schema: {
        "$schema": "http://json-schema.org/draft-07/schema#",
        "type": "object",
        "title": "获取项目类型树",
        "properties": {
            "ver": {
                "type": "string",
                "title": "版本号，默认1.0",
                "default": "1.0"
            },
            "app_id": {
                "type": "string",
                "title": "平台分配的app id"
            },
            "token": {
                "type": "string",
                "title": "登录后获得的令牌"
            },
            "timestamp": {
                "type": "integer",
                "title": "时间戳"
            },
            "sign": {
                "type": "string",
                "title": "签名"
            },
            "data": {
                "type": "object",
                "title": "业务参数",
                "properties": {
                    "pid": {
                        "type": "integer",
                        "title": "无父类型时取整个类型树"
                    },
                }
            }

        },
        "required": [
            "ver", "app_id", "timestamp", "data"
        ]
    },
    method: DataCURD.internal_get_tree,
    method_params: {
        model: AcsDomain,
        addition: {
            pid: 300,
            category: ['prj_type'],
            with_pid: false,
            output_name: 'tree'
        }
    }
}


module.exports = {
    default: v1_0,
    v1_0: v1_0
}
