// 任务计划草稿中的记录变化情况
export enum ChangeMarker {
    NoChange = 0,
    Changed = 1,
    Added = 2,
    Deleted = 3,
}


// 计划任务状态
export enum TaskStatus {
    New = 0,                // 未开始
    Doing = 10,             // 进行中
    OutTime = 20,           // 超时
    Rejected = 30,          // 审核不通过
    ApplyForReview = 40,    // 申请审核
    Reviewing = 50,         // 审核中
    DueDone = 80,           // 已逾期完成
    Cancelled = 90,         // 已取消
    Completed = 100,        // 已完成
}

// 交付物状态
export enum OutcomeStatus {
    New = 0,
    Uploaded = 5,
    ApplyForReview = 10,
    Reviewing = 20,
    Rejected = 30,
    Completed = 100
}

export enum PrjFileType {
    Contract = 'contract',
    WeekReport = 'week_report',
    Outcome = 'outcome',
}

// 任务审核流程
export interface IChecker {
    name: string;               // 审核动作名，如互校、二审、终审
    handlers: Array<string>;
    due_day?: number;
}

// export interface Handler {
//     /**
//      * 处理人账号id
//      */
//     id: string;
//     /**
//      * 处理人名称
//      */
//     name: string;
// }


export interface IStatInfo {
    name: string;   // 名称
    value: number;  // 值
    unit: string;   // 单位
    color?: string;  // 字体颜色
}