import {Engine} from "bpmn-engine";
import {EventEmitter} from "node:events";
import dayjs from "dayjs";
const camunda = require('camunda-bpmn-moddle/resources/camunda.json');
export async function test() {
    let source = `
 <?xml version="1.0" encoding="UTF-8"?>
<bpmn2:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn2="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" xmlns:camunda="http://camunda.org/schema/1.0/bpmn" id="sample-diagram" targetNamespace="http://bpmn.io/schema/bpmn" xsi:schemaLocation="http://www.omg.org/spec/BPMN/20100524/MODEL BPMN20.xsd">
  <bpmn2:process id="Process_1" name="ttt" isExecutable="true">
    <bpmn2:startEvent id="StartEvent_1">
      <bpmn2:outgoing>Flow_15zn1tu</bpmn2:outgoing>
    </bpmn2:startEvent>
    <bpmn2:userTask id="task_request" name="申请" camunda:assignee="$data.user_id">
      <bpmn2:extensionElements>
        <camunda:formData>
          <camunda:formField id="FormField_1grk6p0" label="name" type="string" />
        </camunda:formData>
      </bpmn2:extensionElements>
      <bpmn2:incoming>Flow_15zn1tu</bpmn2:incoming>
      <bpmn2:incoming>Flow_0nwaga3</bpmn2:incoming>
      <bpmn2:incoming>Flow_0nzbvpg</bpmn2:incoming>
      <bpmn2:outgoing>Flow_1rg4oob</bpmn2:outgoing>
      <bpmn2:outgoing>Flow_0bhibn0</bpmn2:outgoing>
    </bpmn2:userTask>
    <bpmn2:sequenceFlow id="Flow_15zn1tu" sourceRef="StartEvent_1" targetRef="task_request" />
    <bpmn2:sequenceFlow id="Flow_1rg4oob" sourceRef="task_request" targetRef="task_approve" />
    <bpmn2:userTask id="task_approve" name="审核" camunda:formKey="pass">
      <bpmn2:extensionElements>
        <camunda:formData>
          <camunda:formField id="pass" label="pass" type="boolean" defaultValue="false" />
        </camunda:formData>
      </bpmn2:extensionElements>
      <bpmn2:incoming>Flow_1rg4oob</bpmn2:incoming>
      <bpmn2:outgoing>Flow_193tusd</bpmn2:outgoing>
    </bpmn2:userTask>
    <bpmn2:exclusiveGateway id="Gateway_06baw71">
      <bpmn2:incoming>Flow_193tusd</bpmn2:incoming>
      <bpmn2:outgoing>Flow_0zubkyw</bpmn2:outgoing>
      <bpmn2:outgoing>Flow_0nwaga3</bpmn2:outgoing>
    </bpmn2:exclusiveGateway>
    <bpmn2:sequenceFlow id="Flow_193tusd" sourceRef="task_approve" targetRef="Gateway_06baw71" />
    <bpmn2:endEvent id="Event_15877ow">
      <bpmn2:incoming>Flow_0zubkyw</bpmn2:incoming>
    </bpmn2:endEvent>
    <bpmn2:sequenceFlow id="Flow_0zubkyw" sourceRef="Gateway_06baw71" targetRef="Event_15877ow">
      <bpmn2:conditionExpression xsi:type="bpmn2:tFormalExpression" language="JavaScript">pass=true;</bpmn2:conditionExpression>
    </bpmn2:sequenceFlow>
    <bpmn2:sequenceFlow id="Flow_0nwaga3" sourceRef="Gateway_06baw71" targetRef="task_request">
      <bpmn2:conditionExpression xsi:type="bpmn2:tFormalExpression" language="JavaScript">pass=false;</bpmn2:conditionExpression>
    </bpmn2:sequenceFlow>
    <bpmn2:sequenceFlow id="Flow_0nzbvpg" sourceRef="Event_catch" targetRef="task_request" />
    <bpmn2:sequenceFlow id="Flow_0bhibn0" sourceRef="task_request" targetRef="task_with_draw" />
    <bpmn2:userTask id="task_with_draw" name="撤回" camunda:formKey="cancel">
      <bpmn2:extensionElements>
        <camunda:formData>
          <camunda:formField id="withdraw" label="是否撤回" type="boolean" defaultValue="false" />
        </camunda:formData>
        <camunda:inputOutput>
          <camunda:outputParameter name="Output_2mfmjbe">
            <camunda:script scriptFormat="JavaScript">{"withdraw":true}</camunda:script>
          </camunda:outputParameter>
        </camunda:inputOutput>
      </bpmn2:extensionElements>
      <bpmn2:incoming>Flow_0bhibn0</bpmn2:incoming>
      <bpmn2:outgoing>Flow_0tj9nd6</bpmn2:outgoing>
    </bpmn2:userTask>
    <bpmn2:sequenceFlow id="Flow_0tj9nd6" sourceRef="task_with_draw" targetRef="Event_throw" />
    <bpmn2:boundaryEvent id="Event_catch" name="撤回" attachedToRef="task_approve">
      <bpmn2:outgoing>Flow_0nzbvpg</bpmn2:outgoing>
      <bpmn2:signalEventDefinition id="SignalEventDefinition_111s194" signalRef="Signal_0hhmd7l" />
    </bpmn2:boundaryEvent>
    <bpmn2:intermediateThrowEvent id="Event_throw">
      <bpmn2:incoming>Flow_0tj9nd6</bpmn2:incoming>
      <bpmn2:signalEventDefinition id="SignalEventDefinition_1tt7p06" signalRef="Signal_0hhmd7l" />
    </bpmn2:intermediateThrowEvent>
  </bpmn2:process>
  <bpmn2:signal id="Signal_0hhmd7l" name="cancel_sign" />
  <bpmn2:message id="Message_0fh9t3e" name="msg_cancel" />
  <bpmn2:message id="Message_1qtzp8g" name="Message_0q7qbc4" />
  <bpmndi:BPMNDiagram id="BPMNDiagram_1">
    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_1">
      <bpmndi:BPMNEdge id="Flow_0tj9nd6_di" bpmnElement="Flow_0tj9nd6">
        <di:waypoint x="500" y="290" />
        <di:waypoint x="552" y="290" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="Flow_0bhibn0_di" bpmnElement="Flow_0bhibn0">
        <di:waypoint x="380" y="190" />
        <di:waypoint x="380" y="290" />
        <di:waypoint x="400" y="290" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="Flow_0nzbvpg_di" bpmnElement="Flow_0nzbvpg">
        <di:waypoint x="540" y="208" />
        <di:waypoint x="540" y="230" />
        <di:waypoint x="400" y="230" />
        <di:waypoint x="400" y="190" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="Flow_0nwaga3_di" bpmnElement="Flow_0nwaga3">
        <di:waypoint x="680" y="125" />
        <di:waypoint x="680" y="50" />
        <di:waypoint x="380" y="50" />
        <di:waypoint x="380" y="110" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="Flow_0zubkyw_di" bpmnElement="Flow_0zubkyw">
        <di:waypoint x="705" y="150" />
        <di:waypoint x="772" y="150" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="Flow_193tusd_di" bpmnElement="Flow_193tusd">
        <di:waypoint x="590" y="150" />
        <di:waypoint x="655" y="150" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="Flow_1rg4oob_di" bpmnElement="Flow_1rg4oob">
        <di:waypoint x="430" y="150" />
        <di:waypoint x="490" y="150" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNEdge id="Flow_15zn1tu_di" bpmnElement="Flow_15zn1tu">
        <di:waypoint x="278" y="150" />
        <di:waypoint x="330" y="150" />
      </bpmndi:BPMNEdge>
      <bpmndi:BPMNShape id="_BPMNShape_StartEvent_2" bpmnElement="StartEvent_1">
        <dc:Bounds x="242" y="132" width="36" height="36" />
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="Activity_09wmdbt_di" bpmnElement="task_request">
        <dc:Bounds x="330" y="110" width="100" height="80" />
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="Activity_0ds6ym0_di" bpmnElement="task_approve">
        <dc:Bounds x="490" y="110" width="100" height="80" />
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="Gateway_06baw71_di" bpmnElement="Gateway_06baw71" isMarkerVisible="true">
        <dc:Bounds x="655" y="125" width="50" height="50" />
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="Event_15877ow_di" bpmnElement="Event_15877ow">
        <dc:Bounds x="772" y="132" width="36" height="36" />
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="Activity_0fonc56_di" bpmnElement="task_with_draw">
        <dc:Bounds x="400" y="250" width="100" height="80" />
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="Event_0mceau4_di" bpmnElement="Event_throw">
        <dc:Bounds x="552" y="272" width="36" height="36" />
      </bpmndi:BPMNShape>
      <bpmndi:BPMNShape id="Event_0s1xb2l_di" bpmnElement="Event_catch">
        <dc:Bounds x="522" y="172" width="36" height="36" />
        <bpmndi:BPMNLabel>
          <dc:Bounds x="529" y="215" width="22" height="14" />
        </bpmndi:BPMNLabel>
      </bpmndi:BPMNShape>
    </bpmndi:BPMNPlane>
  </bpmndi:BPMNDiagram>
</bpmn2:definitions>

    `;

    let engine = new Engine({
        name: 'execution example',
        source,
        moddleOptions: {
            camunda,
        },
        variables: {
            handlers: ['user1', 'user2', 'user3'],
            count: 0
        },
    });

    const engine1 = new Engine({
        name: 'service task example 1',
        source,
        moddleOptions: {
            camunda,
        },
        services: {
            serviceFn(scope, callback) {
                callback(null, { data: 1 });
            },
        },
    });


    engine.getDefinitions().then((definitions) => {
        console.log('Loaded', definitions[0].id);
        console.log('The definition comes with process', definitions[0].getProcesses()[0].id);
    });

    const listener = new EventEmitter();

    // listener.on('wait', async (task) => {
    //     console.log(`${task.id} wait`);
    //
    //         // console.log(task.content.form);
    //         // task.signal({
    //         //     needsRepairs: "Yes",
    //         // });
    // });

    listener.on('flow.take', (flow) => {
        console.log(`flow <${flow.id}> was taken. `+ engine.state);
    });

    listener.on('activity.wait', async (task, engineApi) => {
        console.log(`activity wait ${task.id}`);
        // console.log(engineApi.environment.variables);
        if (task.id === 'task_request') {
            let state = await engine.getState();
            console.log(task.camunda)
            console.log(task.owner.behaviour);
            console.log(state);
            // task.signal();
        }
        if (task.id === 'Approve') {
            // engineApi.environment.variables['needsRepairs'] = "Yes";
            // engineApi.environment.variables['input'] = 30;
            // task.environment.variables.approval = 'Reject';
            // task.signal();
            // let state = await engine.getState();
            // store = state;
            // // console.log(state);
            // await engine.stop();
        }
        if (task.id === 'task_with_draw') {
            task.signal();
            // task.signal({id: 'cancel_signsdfdf'});
            // const execution = await engine.execute();
            // execution.signal({
            //     id: 'withdraw',
            // });
        }
    })

    listener.on('activity.end', (task, execution) => {
        console.log(`activity end ${task.id}`);
        console.log(execution.environment.variables);
    })

    listener.on('activity.enter', (activity, engineApi) => {

        console.log(`activity <${activity.id}> was enter. `+ engineApi.state);



    });

    const timerState = {
        timers: {}
    };
    listener.on('activity.timer', async (activity, execution) => {
        console.log(`activity <${activity.id}> was timer. `+ execution.state);

        activity.dueDate = dayjs().add(35, 'seconds');
        execution.signal(activity.id, 'timer');

    });

    engine.on('activity.timeout', (activity) => {
        console.log(`任务 ${activity.id} 超时`);
    });

    engine.once('end', (execution) => {
        console.log(execution.environment.variables);
    });

    engine.execute({listener,
    },(err, execution) => {
        if (err) console.log(err);
        console.log('Execution completed with id', execution?.environment.variables.id);
    });

}